package com.alihealth.d2d.provtest.domain;

import com.alihealth.d2d.provtest.domain.eto.BASQXQ;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.dataformat.xml.annotation.JacksonXmlElementWrapper;
import com.fasterxml.jackson.dataformat.xml.annotation.JacksonXmlProperty;
import lombok.Builder;
import lombok.Data;

import java.util.Date;
import java.util.List;

/**
 * 进口药品基本信息数据子集(ImportedDrugBaseInfo)表实体类
 *
 * @author makejava
 * @since 2025-06-11 17:43:40
 */
@SuppressWarnings("serial")
@Data
@Builder
@TableName("imported_drug_base_info")
public class ImportedDrugBaseInfo {
    //主键ID
    @TableId(value = "id", type = IdType.AUTO)
    private Long id;
    //事件流水号
    private String eventId;

    //国家药品标识码
    @JacksonXmlProperty(localName = "GJYPBSM")
    private String gjypbsm;
    //药品英文名称

    @JacksonXmlProperty(localName = "YPYWMC")
    private String ypywmc;
    //进口药品中文译名

    @JacksonXmlProperty(localName = "JKYPZWYM")
    private String jkypzwym;
    //药品商品名称

    @JacksonXmlProperty(localName = "YPSPMC")
    private String ypspmc;
    //药品本位码

    @JacksonXmlProperty(localName = "YPBWM")
    private String ypbwm;
    //剂型

    @JacksonXmlProperty(localName = "JX")
    private String jx;
    //制剂规格

    @JacksonXmlProperty(localName = "ZJGG")
    private String zjgg;
    //包装规格

    @JacksonXmlProperty(localName = "BZGG")
    private String bzgg;
    //包装转换比

    @JacksonXmlProperty(localName = "BZZHB")
    private Integer bzzhb;
    //包装转换比单位

    @JacksonXmlProperty(localName = "BZZHBDW")
    private String bzzhbdw;
    //药品有效期

    @JacksonXmlProperty(localName = "YPYXQ")
    private Integer ypyxq;
    //药品有效期单位

    @JacksonXmlProperty(localName = "YPYXQDW")
    private String ypyxqdw;
    //药品批准文号

    @JacksonXmlProperty(localName = "YPPZWH")
    private String yppzwh;
    //药品批准文号有效期

    @JacksonXmlProperty(localName = "YPPZWHYXQ")
    private Date yppzwhyxq;
    //进口药品注册证号

    @JacksonXmlProperty(localName = "JKYPZCZH")
    private String jkypzczh;
    //进口药品注册证有效期

    @JacksonXmlProperty(localName = "JKYPZCZYXQ")
    private Date jkypzczyxq;
    //进口药品批件号

    @JacksonXmlProperty(localName = "JKYPPJH")
    private String jkyppjh;
    //进口药品批件有效期

    @JacksonXmlProperty(localName = "JKYPPJYXQ")
    private Date jkyppjyxq;
    //药品注册分类

    @JacksonXmlProperty(localName = "YPZCFL")
    private String ypzcfl;
    //国家基本药物标识

    @JacksonXmlProperty(localName = "GJJBYWBSM")
    private String gjjbywbs;
    //特殊药品管理分类

    @JacksonXmlProperty(localName = "TSYPGLFL")
    private String tsypglfl;
    //处方药标识

    @JacksonXmlProperty(localName = "CFYBS")
    private String cfybs;
    //境外药品上市许可持有人代码

    @JacksonXmlProperty(localName = "JWYPSSXKCYRDM")
    private String jwypssxkcyrdm;
    //境外药品生产企业代码

    @JacksonXmlProperty(localName = "JWYPSCQYDM")
    private String jwypscqydm;
    //分包装厂名称

    @JacksonXmlProperty(localName = "FBZCMC")
    private String fbzcmc;
    //统一社会信用代码（分包装厂）

    @JacksonXmlProperty(localName = "TYSHXYDMFBZC")
    private String tyshxydmfbzc;
    //分包装厂地址

    @JacksonXmlProperty(localName = "FBZCDZ")
    private String fbzcdz;
    //进口药品代理企业名称

    @JacksonXmlProperty(localName = "JKYPDLQYMC")
    private String jkypdlqymc;
    //统一社会信用代码(进口药品代理企业)

    @JacksonXmlProperty(localName = "TYSHXYDMJKYPDLQY")
    private String tyshxydmjkypdlqy;

    @JacksonXmlProperty(localName = "SCZT")
    //生产状态：1-有效，2-无效
    private String sczt;
    //包装规格标识

    @JacksonXmlProperty(localName = "BZGGBS")
    private String bzggbs;
    //子集：bzbl-包装比例 、bzjb-包装级别 、ypbsm-药品标识码
    private String basqxqs;

    // XML映射字段（不直接存入数据库）
    @TableField(exist = false)
    @JacksonXmlElementWrapper(localName = "BASQXQS")
    @JacksonXmlProperty(localName = "BASQXQ")
    private List<BASQXQ> basqxqList;

    @JacksonXmlProperty(localName = "JWYPSSXKCYRMCZW")
    private String jwypssxkcyrmczw;

    @JacksonXmlProperty(localName = "JWYPSSXKCYRMCYW")
    private String jwypssxkcyrmcyw;

    @JacksonXmlProperty(localName = "JWYPSSXKCYRDZZW")
    private String jwypssxkcyrdzzw;

    @JacksonXmlProperty(localName = "JWYPSCQYMCZW")
    private String jwypscqymczw;

    @JacksonXmlProperty(localName = "JWYPSCQYMCYW")
    private String jwypscqymcyw;

    @JacksonXmlProperty(localName = "JWYPSCQYDZZW")
    private String jwypscqydzzw;

    @JacksonXmlProperty(localName = "JWYPSCQYDZYW")
    private String jwypscqydzyw;

    //创建时间
    private Date createTime;

    //更新时间
    private Date updateTime;

    //是否删除(0-否 1-是)
    private Integer isDeleted;

    // 在setter方法中完成转换
    public void setBasqxqList(List<BASQXQ> basqxqList) {
        this.basqxqList = basqxqList;
        try {
            this.basqxqs = new ObjectMapper().writeValueAsString(basqxqList);
        } catch (JsonProcessingException e) {
            throw new RuntimeException("转换BASQXQS为JSON失败", e);
        }
    }

}

