package com.alihealth.d2d.provtest.service.handle.business;

import com.alihealth.d2d.provtest.domain.ImportedDrugBaseInfo;
import com.alihealth.d2d.provtest.entity.EventBody;
import com.alihealth.d2d.provtest.entity.InstanceDetail;
import com.alihealth.d2d.provtest.entity.ItemDetail;
import com.alihealth.d2d.provtest.entity.VTTSBasic;
import com.alihealth.d2d.provtest.service.ImportedDrugBaseInfoService;
import com.alihealth.d2d.provtest.service.handle.AbstractEventDataHandler;
import com.alihealth.d2d.provtest.service.handle.EventSubType;
import com.alihealth.d2d.provtest.service.impl.XmlParserServiceImpl;
import com.baomidou.mybatisplus.extension.service.IService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @author Jason 进口药品基本信息数据子集
 * @date 2025年06月05日 11:14:43
 */
@Service
@EventSubType("1019")
public class SubType1019Handler extends AbstractEventDataHandler<ImportedDrugBaseInfo> {

    protected final Logger log = LoggerFactory.getLogger(getClass());

    @Autowired
    private ImportedDrugBaseInfoService service;

    @Autowired
    private XmlParserServiceImpl xmlParserServiceImpl;

    @Override
    protected Class<ImportedDrugBaseInfo> getEntityClass() {
        return ImportedDrugBaseInfo.class;
    }

    @Override
    protected IService<ImportedDrugBaseInfo> getService() {
        return service;
    }

    @Override
    protected ImportedDrugBaseInfo convertToEntity(EventBody eventBody, ItemDetail item, InstanceDetail instance, String eventId) {
        return null;
    }

    @Override
    public String getSubType() {
        return "1019";
    }

    @Override
    public void handleBase(String xml,String eventId) {
        VTTSBasic<ImportedDrugBaseInfo> result = xmlParserServiceImpl.parseDataXml(
                xml,
                ImportedDrugBaseInfo.class
        );
        List<ImportedDrugBaseInfo> list = result.getDataset();
        if(list!=null && !list.isEmpty()){
            list.stream()
                    .forEach(item -> {
                        item.setEventId(eventId);
                    });
            getService().saveBatch(list);
            log.info("数据类型："+getSubType()+"，入库的数据条数:{}", list.size());
        }
    }
}
